package main

import (

   "fmt"

   "github.com/myzhan/boomer"

   "log"

   "net/http"

   "net/url"

   "time"

)



func req_baidu()  {

    //开始

   start := time.Now()

   //请求结构体

   baseUrl,_:=url.Parse("https://www.baidu.com/")

   urlpath := baseUrl.String()

   fmt.Printf(urlpath)

   resp, err := http.Get(urlpath)

   if err !=nil{

      log.Println(err)

      return

   }

   defer resp.Body.Close()

   //结束统计

   elapsed := time.Since(start)

   if resp.Status == "200 OK"{

      boomer.RecordSuccess("http","baidu_success",

         elapsed.Nanoseconds()/int64(time.Millisecond),int64(10))

   } else {

      boomer.RecordFailure("http","baidu_failure",

         elapsed.Nanoseconds()/int64(time.Millisecond),"baidu not equal")

   }

}



func main()  {

   task1 := &boomer.Task{

      Name: "baidu",

      Weight: 20,

      Fn: req_baidu,

   }

   boomer.Run(task1)

}


/*
locust --master -f master.py

go run slave.go --master-host=127.0.0.1 --master-port=5557
# 其它附加命令：
--max-rps 200 表示设置最大RPS
--rpc=goczmq  表示用goczmq库代替zeromq库，默认是zeromq库
--rpc=socket  表示用socket方式
# 举例:
cd .go目录 & go run .go文件 --master-host=127.0.0.1 --master-port=5557 --max-rps 200
# locust界面USER数设置==max-rps（即精准控制RPS）
*/
