package datastructure


import (
	"strconv"
	"strings"
)

// ListNode 链表结构
type ListNode struct {
	Val int
	Next *ListNode
}

// StringToListNode 字符串转链表
func StringToListNode(s string) (head *ListNode) {
	s = strings.TrimLeft(s, "[")
	s = strings.TrimRight(s, "]")
	arr := strings.Split(s, ",")
	if len(arr) == 0 || arr[0] == "null" {
		return nil
	}
	head = new(ListNode)
	node := head
	for k, v := range arr {
		node.Val, _ = strconv.Atoi(v)
		if k != len(arr) - 1 {
			node.Next = new(ListNode)
			node = node.Next
		}
	}
	return
}
